<template>
  <div class="vue-ruler-wrapper" :class="{ loaded: loaded }">
    <div ref="iScrollEl" class="vue-i-scroll-wrapper">
      <div class="vue-i-scroll-inner" :style="{ width: `${innerWidth}px` }">
        <ul :style="{ width: `${innerWidth}px` }">
          <li
            v-for="(item, i) in list"
            :key="i"
            :style="{ width: `${unit}px` }"
            :class="{ high: item.isMark, active: value == item.value }"
            :data-num="item.value"
            @click="onItemClick(item)"
          >
            <span v-if="item.isMark">{{ format(item.value) }}</span>
          </li>
        </ul>
      </div>
    </div>
    <span class="vue-ruler-current">{{ format(num) }}</span>
  </div>
</template>

<script>
import IScroll from '../../plugins/iscroll-probe'

export default {
  name: 'MeterSlider',
  props: {
    min: { type: Number, default: 0 },
    max: { type: Number, default: 1000 },
    step: { type: Number, default: 10 },
    unit: { type: Number, default: 10 },
    value: { type: Number, default: 0 },
    format: { type: Function, default: value => value }
  },
  data() {
    return {
      num: 0,
      iScroll: null,
      loaded: false
    }
  },
  computed: {
    innerWidth() {
      return (this.max + 1 - this.min) * this.unit
    },
    list() {
      let list = []
      for (let i = this.min; i <= this.max; i++) {
        list.push({
          isMark: i % this.step === 0,
          value: i
        })
      }
      return list
    }
  },
  watch: {
    value: 'setValue'
  },
  mounted() {
    this.$nextTick(this.init)
  },
  updated() {},
  beforeDestroy() {
    this.iScroll.destroy()
    this.iScroll = null
  },
  methods: {
    init() {
      let vm = this
      this.iScroll = new IScroll(this.$refs.iScrollEl, {
        probeType: 3,
        click: true,
        scrollX: true,
        scrollY: false,
        disablePointer: true,
        disableTouch: false,
        disableMouse: false,
        preventDefault: true
      })
      this.iScroll.on('scroll', function() {
        let num = -Math.floor(this.x.toFixed(0) / vm.unit)
        num += vm.min
        if (num >= vm.min && num <= vm.max) {
          vm.num = num
          vm.$emit('input', vm.num)
        }
      })
      this.iScroll.on('scrollEnd', function() {
        let _value = Math.floor(this.x.toFixed(0) / vm.unit) * vm.unit
        if (Math.abs(_value) > (vm.max - vm.min) * vm.unit) {
          vm.scrollTo(vm.max, 200)
        } else {
          this.scrollTo(Math.floor(this.x.toFixed(0) / vm.unit) * vm.unit, 0, 0)
        }
      })
      setTimeout(() => {
        this.loaded = true
        this.$nextTick(this.setValue)
      }, 300)
    },
    scrollTo(value, t = 0) {
      this.iScroll.scrollTo((-value + this.min) * this.unit, 0, t)
    },
    setValue(value) {
      if (arguments.length === 0) value = parseInt(this.value)
      if (this.iScroll && this.num !== value) {
        this.scrollTo(value, 500)
      }
    },
    onItemClick(item) {
      this.num = item.value
      this.scrollTo(item.value, 500)
    }
  }
}
</script>

<style lang="scss">
@import '../../assets/sass/variables';
.vue-ruler-wrapper {
  height: 40px;
  position: relative;
  direction: ltr;
  text-align: left;
  width: 100%;
  overflow: hidden;
  user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  -webkit-user-select: none;
  color: #757575;
  background-color: #eceaeb;
  padding: 2px 0;
  opacity: 0;
  transition: opacity 0.6s ease-in-out;
  border-radius: 5px;
  &.loaded {
    opacity: 1;
  }
  /*&:before {
    position: absolute;
    left: 0;
    top: 0;
    width: 0;
    height: 100%;
    background: white;
    content: '';
    z-index: 20;
    box-shadow: 5px 0 12px 15px rgba(white, 0.5);
  }
  &:after {
    position: absolute;
    right: 0;
    top: 0;
    width: 0;
    height: 100%;
    background: white;
    content: '';
    z-index: 20;
    box-shadow: -5px 0 12px 15px rgba(white, 0.5);
  }*/
}
.vue-ruler-current {
  position: absolute;
  top: 5px;
  left: 50%;
  transform: translateX(-50%);
  padding: 3px 15px;
  font-size: 12px;
  border-radius: 20px;
  background-color: $primary;
  color: white;
  z-index: 10;
}
.vue-i-scroll-wrapper {
  height: 100%;
  transform: translateX(50%);
}
.vue-i-scroll-inner {
  height: 100%;
  padding: 0 100% 0 0;
  box-sizing: content-box;
  ul {
    height: 100%;
    white-space: nowrap;
    display: flex;
    padding: 0;
    margin: 0;
    overflow: visible;
    list-style-type: none;
    li {
      height: 100%;
      position: relative;
      cursor: pointer;
      span {
        position: absolute;
        bottom: 30%;
        left: 0;
        transform: translateX(-50%);
        font-size: 12px;
      }
      &:before {
        content: '';
        position: absolute;
        bottom: 0;
        left: 0;
        height: 15%;
        border-left: 1px solid #c2c2c2;
      }
      &.high:before {
        height: 25%;
        border-left-color: #656565;
      }
      &:hover {
        span {
          color: red;
        }
        &:before {
          border-left-color: red;
        }
      }
    }
  }
}
.vue-ruler-wrapper.simple {
  .vue-i-scroll-inner ul li {
    &:before {
      display: none;
    }

    span {
      top: 50%;
      bottom: auto;
      transform: translate(-50%, -50%);
      background-color: rgba($success, 0.5);
      color: white;
      position: absolute;
      padding: 3px 15px;
      font-size: 12px;
      border-radius: 20px;
    }

    &.active {
      span {
        background-color: $primary;
      }
    }
  }

  .vue-ruler-current {
    display: none;
  }
}
</style>
